import Pokemon from './interface.pokemon';
import ListOf from './ListOf';
import dex from './dex/Dex';

interface PokedexJSOptions {
  entries: string[];
  output: string; // Object, JSON, FormattedList, HTMLTemplate
  filter: Function;
}


export class PokedexJS {
  public template: Function;

  public constructor() {

  }

  private createPokedexArray(entries:string[]):number[] {
    let PokedexArray: number[];
    for (let entry in entries) {
      let splitEntryArray = entry.split('-');
      if (splitEntryArray.length === 0) {
        throw new TypeError('Entries cannot have a length of 0.');
      }
      if (splitEntryArray.length === 1) {
        PokedexArray.push(Number(splitEntryArray[0]));
      }
      if (splitEntryArray.length === 2) {
        let splitEntryA = Number(splitEntryArray[0]);
        let splitEntryB = Number(splitEntryArray[1]);

        if (splitEntryA > splitEntryB) {
          throw new Error('First part of entry must be lower number.');
        } else {
          for (let splitEntry in splitEntryArray) {
            while (splitEntryA < splitEntryB) {
              PokedexArray.push(splitEntryA);
              splitEntryA++;
            }
          }
        }
      }
      if (splitEntryArray.length > 2) {
        throw new TypeError('Each entry cannot have more than 2 numbers');
      }
    }

    return PokedexArray;
  }

  public createPokedex(entries: string[], output: string, filter: Function):any {
    let PokedexArray: number[] = this.createPokedexArray(entries);
  }

}

export default PokedexJS;


// PokedexJS.createPokedex(['1-39', '43', '231-334'])

/*
let options = {
  entries: ['1-39', '33', '124'],
  output: 'JSON'
}

PokedexJS.createPokedex(options)

*/
