import Pokemon from '../interface.pokemon';
import { DexNumber, GenderRatio, PokemonTypes, Item, Location, Evolution, Move, SpecialMove, PreEvoMove, TransferOnlyMove, LevelUpMove, Description } from '../interface.pokemonattributes';
import ListOf from '../ListOf';

export class CroagunkClass implements Pokemon {
  species = 'Croagunk';
  sprite = 'croagunk.png';
  spriteShiny = 'croagunk-s.png';
  dexNumbers:DexNumber[] =  [ { region: 'National', num: 453 }];
  genderRatio:number = 0.5;
  types = new ListOf(['Poison', 'Fighting']);
  abilities = ['Anticipation', 'Dry Skin', 'Poison Touch'];
  height = 1000;
  weight = 1000;
  baseStats = [1, 1, 1, 1, 2, 3];
}

export class CroagunkMega extends CroagunkClass {
  species = 'Croagunk-Mega';
  baseStats = [100, 200, 300, 400, 555];
}

export let Croagunk = new CroagunkClass();

/*
interface Pokemon {
  species: string;
  sprite: string;
  spriteShiny: string;
  dexNumbers: DexNumber[];
  genderRatio: number;
  types: ListOf<string>;
  abilities: string[];
  experienceGrowth?: number;
  experienceGrowthName?: string;
  baseHappiness?: number;
  height: number;
  weight: number;
  captureRate?: number;
  baseEggSteps?: number;
  // TODO: Better EV interface
  effortValues?: string;
  evolutionaryChain?: Evolution[];
  wildHoldItems?: Item[];
  bodyShape?: string;
  locations?: Location[];
  description?: Description[];
  levelUpMoves?: LevelUpMove[];
  tmhmMoves?: number[];
  eggMoves?: Move[];
  tutorMoves?: Move[];
  specialMoves?: SpecialMove[];
  preEvoMoves?: PreEvoMove[];
  transferOnlyMoves?: TransferOnlyMove[];
  baseStats: number[];
  [propName: string]: any;
}
*/
