import ListOf from './ListOf';

import { DexNumber,
         GenderRatio,
         PokemonTypes,
         Item,
         Location,
         Evolution,
         Move,
         SpecialMove,
         PreEvoMove,
         TransferOnlyMove,
         LevelUpMove,
         Description } from './interface.pokemonattributes';


interface Pokemon {
  species: string;
  // TODO: better interface for formes
  formes?: string;
  sprite?: string;
  spriteShiny?: string;
  dexNumbers: DexNumber[];
  genderRatio: number;
  types: ListOf<string>;
  abilities: string[];
  experienceGrowth?: number;
  experienceGrowthName?: string;
  baseHappiness?: number;
  height: number;
  weight: number;
  captureRate?: number;
  baseEggSteps?: number;
  // TODO: Better EV interface
  effortValues?: string;
  evolutionaryChain?: Evolution[];
  wildHoldItems?: Item[];
  bodyShape?: string;
  locations?: Location[];
  description?: Description[];
  levelUpMoves?: LevelUpMove[];
  tmhmMoves?: number[];
  eggMoves?: Move[];
  tutorMoves?: Move[];
  specialMoves?: SpecialMove[];
  preEvoMoves?: PreEvoMove[];
  transferOnlyMoves?: TransferOnlyMove[];
  baseStats: number[];
  [propName: string]: any;
}




export default Pokemon;
